/*
 * CountUp class.
 *
 * Copyright (C) 2007 SATOH Takayuki All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
package ts.util;

import java.math.BigDecimal;
import java.io.Serializable;

/**
 * カウントアップクラス。
 * <br>
 * カウンタの値を保持し、それを一つずつ加算していくためのメソッドを
 * 用意している。
 * カウンタの初期値及び上限値は、デフォルトではそれぞれゼロ及び
 * {@link java.lang.Long#MAX_VALUE} に設定されるが、コンストラクタで指定する
 * こともできる。
 * <br>
 * このクラスの直接のインスタンスはマルチスレッドに対応していないが、
 * {@link ts.util.CountUp#synchronizedCountUp()}メソッドを使用して、
 * スレッドセーフなインスタンスを作成することができる。
 *
 * @author  佐藤隆之. 
 * @version $Revision: 1.2 $, $Date: 2011-08-01 15:29:29 $
 */
public class CountUp implements Serializable
{
  /** シリアル・バージョン番号。 */
  static final long serialVersionUID = 7478966516840533567L;

  /** カウンタ。 */
  private long value_;

  /** 上限値。 */
  private long limit_;

  /**
   * デフォルトコンストラクタ。
   * <br>
   * カウンタの初期値はゼロ、上限値は{@link java.lang.Long#MAX_VALUE}とする。
   */
  public CountUp()
  {
    this(0L, Long.MAX_VALUE);
  }

  /**
   * カウンタの上限値を引数にとるコンストラクタ。
   * <br>
   * カウンタの初期値はゼロとする。カウンタの上限値がゼロよりも小さい場合も、
   * そのまま設定する。
   *
   * @param  limit カウンタの上限値。
   */
  public CountUp(long limit)
  {
    this(0L, limit);
  }

  /**
   * カウンタの初期値と上限値を引数にとるコンストラクタ。
   * <br>
   * 初期値が上限値よりも大きい場合も、そのまま設定する。
   *
   * @param  init カウンタの初期値。
   * @param  limit カウンタの上限値。
   */
  public CountUp(long init, long limit) 
  {
    value_ = init;
    limit_ = limit;
  }

  /**
   * 現在のカウンタ値を取得する。
   *
   * @return 現在のカウンタ値。
   */
  public long currentValue()
  {
    return value_;
  }

  /**
   * 上限値を取得する。
   *
   * @return 上限値。
   */
  public long limitValue()
  {
    return limit_;
  }

  /**
   * カウンタの値が上限値に達したかどうかを判定する。
   *
   * @return カウンタの値が上限値よりも大きいか等しい場合は<tt>true</tt>を返
   *         し、そうでなければ<tt>false</tt>を返す。
   *
   */
  public boolean isReached()
  {
    return (value_ >= limit_) ? true : false;
  }

  /**
   * カウンタを一つ加算する。
   * <br>
   * カウンタの値が上限値を越える場合には例外をスローする。
   *
   * @return 加算後のカウンタ値。
   * @throws OutOfRangeException カウンタが上限値を越える場合。
   */
  public long increment() throws OutOfRangeException
  {
    if (value_ >= limit_) {
      BigDecimal v = new BigDecimal(String.valueOf(value_));
      v.add(BigDecimal.valueOf(1L));
      BigDecimal e = BigDecimal.valueOf(limit_);
      throw new OutOfRangeException(v, null, e);
    }

    value_ ++;
    return value_;
  }

  /**
   * スレッドセーフなカウントアップオブジェクトを生成する。
   * <br>
   * カウンタの初期値はゼロ、上限値は<code>Long.MAX_VALUE</code>とする。
   *
   * @return スレッドセーフなカウントアップオブジェクト。
   */
  public static CountUp synchronizedCountUp()
  {
    return synchronizedCountUp(0L, Long.MAX_VALUE);
  }

  /**
   * カウンタの上限値を指定して、スレッドセーフなカウントアップオブジェクト
   * を生成する。
   * <br>
   * カウンタの初期値はゼロとする。カウンタの上限値がゼロよりも小さい場合も、
   * そのまま設定する。
   * 
   * @param  limit カウンタの上限値。
   * @return スレッドセーフなカウントアップオブジェクト。
   */
  public static CountUp synchronizedCountUp(long limit)
  {
    return synchronizedCountUp(0L, limit);
  }

  /**
   * カウンタの初期値と上限値を指定して、スレッドセーフなカウントアップ
   * オブジェクトを生成する。
   * <br>
   * 初期値が上限値よりも大きい場合も、そのまま設定する。
   *
   * @param  init  カウンタの初期値。
   * @param  limit カウンタの上限値。
   * @return スレッドセーフなカウントアップオブジェクト。
   */
  public static CountUp synchronizedCountUp(long init, long limit)
  {
    return new CountUp(init, limit) {
      static final long serialVersionUID = 7478966516840533568L;

      @Override
      public synchronized long currentValue() {
        return super.currentValue();
      }
      @Override
      public synchronized boolean isReached() {
        return super.isReached();
      }
      @Override
      public synchronized long increment() throws OutOfRangeException {
        return super.increment();
      }
    };
  }

  /**
   * 指定されたカウントアップオブジェクトの現在の値を使用して、
   * スレッドセーフなカウントアップオブジェクトを新たに生成する。
   *
   * @param  c 元になるカウントアップオブジェクト。
   * @return スレッドセーフなカウントアップオブジェクト。
   * @throws AssertionError 引数がヌルの場合（デバッグモードのみ）。
   */
  public static CountUp synchronizedCountUp(CountUp c)
  {
    assert (c != null) : "@param:c is null.";

    return synchronizedCountUp(c.currentValue(), c.limitValue());
  }
}
